%%
temp=ones(8)
tempfft=fft2(temp)
fftshift(fft2(temp))

%%
f = zeros(500,500);
f(240:260,230:270) = 1;
subplot(2,2,1);imshow(f,[]);
F = fftshift(fft2(f));
S = log(1+abs(F)); % take log in order to have a clearer display
subplot(2,2,2);imshow(S,[]);
%%
%Fourier Transform of image
a=imread('1.jpg');
a1=double(rgb2gray(a));
fft_image=fft2(a1); %take the fft of image note:fft is complex
%shift to center, take abs to see spectrum, take log to see small values
figure,imshowpair(a,log(abs(fftshift(fft_image)+1)),'montage') % magnitude spectrum
figure,imshow(angle(fft_image)) % Show phase angle
back_to=ifft2(fft_image);   % We can always go back inverse fft
figure, imshow(back_to/255)

%Fourier Transform of Monalisa
mona=imread('mona-lisa.jpg');
mona2=double(rgb2gray(mona));
fft_mona=fft2(mona2); %take the fft of image note:fft is complex
%shift to center, take abs to see spectrum, take log to see small values
figure,imshow(log(abs(fftshift(fft_mona)+1)),[]) % magnitude spectrum
figure,imshow(angle(fft_mona)) % Show phase angle
back_to_mona=ifft2(fft_mona);   % We can always go back inverse fft
figure, imshow(back_to_mona/255)

%%
% Spatial Domain Filtering and Frequency Domain Filtering
f2 = imread('1.jpg');
h = fspecial('sobel'); 
sfi = imfilter(f2,h, 0, 'conv'); %Display results (show all values)
figure,imshow(sfi);
%%
%Lowpass filtering (frequency domain)
f = imread('1.jpg');
f = double(rgb2gray(f));
F = fftshift(fft2(f));
[m,n] = size(f);
sig = 10;
H = Gaussian(m, n, sig);%create filter which is the same size as image
G = H.*F;
g = abs(ifft2(G));
figure,imshow(g,[]);

%%
%combine the phase of one image and magnitude of different image
first=imread('3.jpg');
new=imresize(first, [401 599]);
fg=im2double(rgb2gray(new));
fft1=fft2(fg);
mag1=abs(fft1);
angle1=angle(fft1);
figure,imshowpair(log(abs(fftshift(fft1)+1)),angle1,'montage');

second=imread('2.jpg');
sg=im2double(rgb2gray(second));
fft2_de=fft2(sg);
mag2=abs(fft2_de);
angle2=angle(fft2_de);
figure, imshowpair(log(abs(fftshift(fft2_de)+1)),angle2,'montage')

C1= mag1.*exp(i*angle2); % mag of first with phase of second
C2= mag2.*exp(i*angle1); % mag of second with phase of first
imageC = ifft2(C1);
imageD = ifft2(C2);
figure, imshowpair(imageC,imageD,'montage')

%% Compress image
I1 = imread('3.jpg');
I=rgb2gray(I1);
I = im2double(I);
T = dctmtx(8);
B = blkproc(I,[8 8],'P1*x*P2',T,T');
mask = [1   1   1   1   0   0   0   0
        1   1   1   0   0   0   0   0
        1   1   0   0   0   0   0   0
        1   0   0   0   0   0   0   0
        0   0   0   0   0   0   0   0
        0   0   0   0   0   0   0   0
        0   0   0   0   0   0   0   0
        0   0   0   0   0   0   0   0];
B2 = blkproc(B,[8 8],'P1.*x',mask);
I2 = blkproc(B2,[8 8],'P1*x*P2',T',T);
figure,imshow(I1)
title('original image')
 figure, imshowpair(I,I2,'montage')
 title('Original gray level image                Compressed image')

